function SEAlab()
% SEAlab is the main function for SEAlab.
%   SEAlab executes functions and loads data required to initialize
%   the graphical user interface.
%
% [Usage]:
%   SEAlab()
%

% Octave compability for the graphical user interface is not implemented
% in current version. Terminate session if function is executed from
% octave.
if exist('OCTAVE_VERSION','var')
    error('Octave compability for the GUI is not implemented yet, calculation functions must be used manually')
end
% add subfolders to MATLAB seach path.
enablepaths
% load subsystem picture into memory before the GUI is initialized.
sub_pictures = dir(['subsystem_pictures' filesep '*.jpg']);
wb = waitbar(0,'Loading Images...');
for ii=1:length(sub_pictures)
    waitbar(ii/length(sub_pictures))
    data.subtypes(ii).name = sub_pictures(ii).name(1:find((sub_pictures(ii).name)=='.')-1);
    data.subtypes(ii).value = loadpicture(data.subtypes(ii).name);
end
close(wb)
% create data structure to handle all variables within the GUI.
data.subsystems = [];
data.numss = 0;
data.numcon = 0;
data.connections.subsystems = [];
data.currentfile=[];
temppath = ['temp' filesep 'tempdata.mat'];
save(temppath,'data')
setappdata(mainui,'data',data);
% Initialize GUI.
mainui
