%**************************************************************************
% SEAlab v0p1 Calculate subsystem and connection properties
%**************************************************************************
% Main file that replances the function calls and calculations in mainui.m
%
% Revision history
% 110401 PA Start to implement a main file that replances the function calls
%           and calculations in mainui.m, copying parts from mainui.m and
%
% 110401 Patrik Andersson

% Calculate subsystem properties
for ii = 1:data.numss
    data.subsystems(ii).values = set_subsystem_values(data.subsystems(ii).type,data.subsystems(ii).values);
    if strcmp(data.subsystems(ii).type,'plate')
        data.subsystems(ii).values.k = calc_k(data.subsystems(ii).values,data.f,data.subsystems(ii).type);
        data.subsystems(ii).values.c = calc_c(data.subsystems(ii).values.k,data.f);
        data.subsystems(ii).values.mden = mden_calc(data.f,data.subsystems(ii).values,data.subsystems(ii).type);
    elseif strcmp(data.subsystems(ii).type,'cavity')
        data.subsystems(ii).values.k = calc_k(data.subsystems(ii).values,data.f,data.subsystems(ii).type);
        data.subsystems(ii).values.mden = mden_calc(data.f,data.subsystems(ii).values,data.subsystems(ii).type);
    end
end

% Calculate connection properties
for ii = 1:data.numcon
    if strcmp(data.connections(ii).type,'plates')
        for jj = 1:length(data.connections(ii).subsystems)
            subsystem_values(jj) = data.subsystems(data.connections(ii).subsystems(jj)).values;
        end
        temp.ss_values = subsystem_values;
        temp.con_values = data.connections(1).values;
        data.connections(ii).tau = tau_plate_plate(data.f,data.connections(ii).values,subsystem_values);
        data.connections(ii).clf = clf_plate_plate(data.f,data.connections(ii),subsystem_values);
    elseif strcmp(data.connections(ii).type,'plate cavity')
        plate_values = data.subsystems(data.connections(ii).plate_nr).values;
        cavity_values = data.subsystems(data.connections(ii).cavity_nr).values;
        plate_clf_tot = 0.02; % = ???
        rad_return = plate_cavity_rad_tau(data.f,plate_values,cavity_values,plate_clf_tot);
        data.connections(ii).tau = rad_return.tau;
        data.connections(ii).radiation_eff = rad_return.rad;
        data.connections(ii).clf = clf_leaf_wall(data.f,plate_values,cavity_values,data.connections(ii));
    elseif strcmp(data.connections(ii).type,'leaf wall')
        plate_values = data.subsystems(data.connections(ii).plate_nr).values;
        cavity_values(1) = data.subsystems(data.connections(ii).cavity_nr(1)).values;
        cavity_values(2) = data.subsystems(data.connections(ii).cavity_nr(2)).values;
        plate_clf_tot = 0.02; % = ???
        rad_return = plate_cavity_rad_tau(data.f,plate_values,cavity_values,plate_clf_tot);
        data.connections(ii).tau = rad_return.tau;
        data.connections(ii).radiation_eff = rad_return.rad;
        data.connections(ii).clf = clf_leaf_wall(data.f,plate_values,cavity_values,data.connections(ii));
    elseif strcmp(data.connections(ii).type,'double wall')
        plate_values(1) = data.subsystems(data.connections(ii).subsystems(2)).values;
        plate_values(2) = data.subsystems(data.connections(ii).subsystems(4)).values;
        cavity_values(1) = data.subsystems(data.connections(ii).subsystems(1)).values;
        cavity_values(2) = data.subsystems(data.connections(ii).subsystems(3)).values;
        cavity_values(3) = data.subsystems(data.connections(ii).subsystems(5)).values;
        data.connections(ii).clf = clf_double_wall(data.f,data.connections(ii).values,plate_values,cavity_values);
    end
    clear subsystem_values plate_values cavity_values;
end
data = energy_calc_v0p0(data);
dirpath = filesep;
temppath = ['results' dirpath 'last_data.mat'];
save(temppath,'data')



