function return_data = clf_leaf_wall(f,plate_values,cavity_values,con_values)
%

% clear all
% load last_data
% f = data.f;
% plate_values=data.subsystems(3).values;
% cavity_values(1) = data.subsystems(1).values;
% cavity_values(2) = data.subsystems(2).values;
% con_values = data.connections(1);

numcavs = length(cavity_values);
numss = length(con_values.subsystems);
h = plate_values.thickness;
rho = plate_values.rho*h;
rho0(1:numcavs) = 0;
c0(1:numcavs) = 0;
fc(1:numcavs) = 0;
for cavs = 1:numcavs
    rho0(cavs) = cavity_values(cavs).rho;
    c0(cavs) = cavity_values(cavs).c;
    fc(cavs) = c0(cavs)^2./(1.8*plate_values.c.l(1)*h);
end
clf(1:numss,1:numss,1:3) = struct('b',zeros(1,length(f)),'l',zeros(1,length(f)),'s',zeros(1,length(f)));
cavs = 0;
for cavs_nr = con_values.cavity_nr
    cavs = cavs + 1;
    plate_pos = find(con_values.plate_nr==con_values.subsystems);
    cavs_pos = find(cavs_nr==con_values.subsystems);
    clf(plate_pos,cavs_pos,1).b = rho0(cavs)*c0(cavs)*con_values.radiation_eff(cavs).rad./(2*pi*f*rho);
    clf(cavs_pos,plate_pos,1).b = clf(plate_pos,cavs_pos,1).b.*plate_values.mden.b./cavity_values(cavs).mden.b;
    if numcavs >1
        cavs2 = 0;
        for cavs_nr2 = con_values.cavity_nr
            if cavs_nr~=cavs_nr2
                cavs2 = cavs2 + 1;
                cavs_pos2 = find(cavs_nr2==con_values.subsystems);
                clf(cavs_pos,cavs_pos2,1).b = c0(cavs)*con_values.values.area*con_values.tau(cavs2).tau./(8*pi*f*cavity_values(cavs).volume);
            end
        end
    end
end



% find(5==data.connections(2).subsystems)
%return_data = 


% *mden_plate/mden_cav


% .*plate_values(con_values.plate_nr==con_values.subsystems).values.mden.b(f>=fc(cavs))./cavity_values(cavs_nr==con_values.subsystems).values.mden.b(f>=fc(cavs))

%           subsystems: [1 2 3]
%             plate_nr: 2
%            cavity_nr: [1 3]
%                 type: 'leaf wall'
%         centre_coord: [32.4952 51.8491]
%                types: {'cavity'  'plate'  'cavity'}
%     properties_saved: 1
%               values: [1x1 struct]
%                  tau: [1x2 struct]
%        radiation_eff: [1x2 struct]
% 
%        material: 1
%          volume: 9
%         damping: 0.0100
%     input_power: [1x1 struct]
%      fluid_type: 'Air'
%               c: 343
%             rho: 1.2100
%             vis: 1.5000e-005
% 
%          material: 11
%         thickness: 1.0000e-003
%           damping: 0.0100
%               dim: [1 1]
%       input_power: [1x1 struct]
%     material_type: 'steel'
%                 E: 2.1000e+011
%               poi: 0.3125
%               rho: 7800
%                 D: 19.3939
%                 k: [1x1 struct]
%                 c: [1x1 struct]
%              mden: [1x1 struct]
