function enablepaths()
% enablepaths adds SEAlab subfolders to MATLAB current search path.
% Required for executing SEAlab function from SEAlab main diroctory.
%
% [Usage]:
%   enablepaths()
%
% 110831 PA enablepaths.m
%           Added the SEAlab paths to the top of the path list instead
%           of at the end, so that files of the correct version is used.

% save diretory paths for each subfolder to string variables.
path_fun = [pwd filesep 'functions'];
path_couplings = [pwd filesep 'couplings'];
path_gui = [pwd filesep 'gui'];
path_data = [pwd filesep 'data'];
path_pic = [pwd filesep 'subsystem_pictures'];
path_temp = [pwd filesep 'temp'];
path_results = [pwd filesep 'results'];
path_images = [pwd filesep 'images'];

% add subfolder paths to current MATLAB search path.
path(path_fun,path)
path(path_couplings,path)
path(path_gui,path)
path(path_data,path)
path(path_pic,path)
path(path_temp,path)
path(path_results,path)
path(path_images,path)
