function im_type = loadpicture(type)
% loadpicture(type) reads the image corresponding to the given type and
% returns the image data.
%   ex. loadpicture('plate') reads the image plate.jpg from the
%   subfolder 'subsystem_pictures', for more help see help for imread.
%
% [Usage]:
%   im_value = loadpicture(type)
%
% [Inputs]:
%   type (string) - name of the subsystem type corresponding to the name of
%                   the subsystem picture in the subsystem_pictures folder.
%                   ex. 'plate', 'cavity' or 'semiinfinitefluid'.
%
% [Output]:
%   im_value (double array) - array containing the image data.
%

% keep image data persistant within the function to prevent loading times
% for already loaded pictures.
persistent loaded_images
eval(['persistent im_' type])
notloaded = eval(['isempty( im_' type ')']);
% read the image with imread
if notloaded
    eval(['im_' type ' = imread(type,' char(39) 'jpeg' char(39) ');'])
end
loaded_images = [loaded_images 'im_' type ' '];
% return image data
eval(['im_type = im_' type ';'])