function varargout = exitation(varargin)
% EXITATION MATLAB code for exitation.fig
%      EXITATION, by itself, creates a new EXITATION or raises the existing
%      singleton*.
%
%      H = EXITATION returns the handle to a new EXITATION or the handle to
%      the existing singleton*.
%
%      EXITATION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EXITATION.M with the given input arguments.
%
%      EXITATION('Property','Value',...) creates a new EXITATION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before exitation_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to exitation_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help exitation

% Last Modified by GUIDE v2.5 14-Oct-2010 23:32:06

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @exitation_OpeningFcn, ...
                   'gui_OutputFcn',  @exitation_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before exitation is made visible.
function exitation_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to exitation (see VARARGIN)

% Choose default command line output for exitation
handles.output = hObject;
image(imread('point_middle.jpg'),'Parent',handles.axis_mid)
axis(handles.axis_mid,'off')
image(imread('point_edge.jpg'),'Parent',handles.axis_edge)
axis(handles.axis_edge,'off')
image(imread('long.jpg'),'Parent',handles.axis_plane)
axis(handles.axis_plane,'off')
inp.type = varargin{1};
inp.f = varargin{2};
if strcmp(inp.type,'plate')
    values = varargin{3};
    inp.h = values.thickness;
    load physicalproperties solids
    inp.rho = solids.rho(values.material);
    inp.E = solids.Ey(values.material);
    inp.poi = solids.poi(values.material);
    inp.D = inp.E*inp.h^3/(12*(1-inp.poi^2));
    end
for ii = 1:length(inp.f)
    freq{ii} = [num2str(inp.f(ii)) ' Hz'];
end
set(handles.tbl_exitation,'Data',zeros(length(inp.f),3))
set(handles.tbl_exitation,'ColumnName',{'Bending [W]' 'Longit. [W]' 'Shear [W]'})
set(handles.tbl_exitation,'Rowname',freq)
set(handles.tbl_exitation,'ColumnWidth','auto')
set(handles.tbl_exitation,'ColumnEditable',[true true true])
set(handles.rbtn_energy,'Value',1)
set(handles.rbtn_average,'Value',1)
set(handles.rbtn_average,'Enable','on')
set(handles.rbtn_mid,'Enable','off')
set(handles.rbtn_edge,'Enable','off')
set(handles.rbtn_plane,'Enable','off')
handles.inp = inp;
% Update handles structure
guidata(hObject, handles);
% UIWAIT makes exitation wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = exitation_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in btn_ok.
function btn_ok_Callback(hObject, eventdata, handles)
% hObject    handle to btn_ok (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles = guidata(hObject); % Get handles
inp = handles.inp;
tbl_data = str2double(get(handles.tbl_exitation,'Data'));
realY_mid = 1/(8*sqrt(inp.D*inp.rho))
realY_edge = 1/(3.5*sqrt(inp.D*inp.rho))
realY_plane = 4*pi*inp.f./(inp.E*inp.h)
realZ_mid = 1./realY_mid
realZ_edge = 1./realY_edge
realZ_plane = 1./realY_plane
inpwr.source = get(handles.txt_source,'String');
if get(handles.rbtn_average,'Value')
    inpwr.type = 'average';
    inpwr.value = tbl_data;
elseif get(handles.rbtn_mid,'Value')
    inpwr.type = 'point exitation, middle';
    if get(handles.rbtn_power,'Value')
        inpwr.value = abs(tbl_data.^2).*realY_mid./2;
    elseif get(handles.rbtn_velocity,'Value')
        inpwr.value = abs(tbl_data.^2).*realZ_mid./2;
    end
elseif get(handles.rbtn_edge,'Value')
    inpwr.type = 'edge';
    if get(handles.rbtn_power,'Value')
        inpwr.value = abs(tbl_data.^2).*realY_edge./2;
    elseif get(handles.rbtn_velocity,'Value')
        inpwr.value = abs(tbl_data.^2).*realZ_edge./2;
    end
elseif get(handles.rbtn_plane,'Value')
    inpwr.type = 'plane';
    if get(handles.rbtn_power,'Value')
        inpwr.value = abs(tbl_data.^2).*realY_plane./2;
    elseif get(handles.rbtn_velocity,'Value')
        inpwr.value = abs(tbl_data.^2).*realZ_plane./2;
    end
end
handles.output = inpwr;

% --- Executes on button press in btn_load.
function btn_load_Callback(hObject, eventdata, handles)
% hObject    handle to btn_load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when selected object is changed in btng_exitation.
function btng_exitation_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in btng_exitation 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
    handles = guidata(hObject); % Get handles
    table_data = get(handles.tbl_exitation,'Data');
    switch get(eventdata.NewValue,'Tag')   % Get Tag of selected object
        case 'rbtn_average'
            set(handles.tbl_exitation,'Data',[table_data table_data table_data])
            set(handles.tbl_exitation,'ColumnEditable',[true true true])
            set(handles.tbl_exitation,'ColumnName',{'Bending' 'Longit.' 'Shear'})
        case 'rbtn_mid'
            set(handles.tbl_exitation,'Data',table_data(:,1))
            set(handles.tbl_exitation,'ColumnEditable',[true])
            set(handles.tbl_exitation,'ColumnName',{'Point exitation, middle'})
        case 'rbtn_edge'
            set(handles.tbl_exitation,'Data',table_data(:,1))
            set(handles.tbl_exitation,'ColumnEditable',[true])
            set(handles.tbl_exitation,'ColumnName',{'Point exitation, edge'})
        case 'rbtn_plane'
            set(handles.tbl_exitation,'Data',table_data(:,1))
            set(handles.tbl_exitation,'ColumnEditable',[true])
            set(handles.tbl_exitation,'ColumnName',{'Plane wave exitation'})
    end
    guidata(hObject, handles);
    

% --- Executes when selected object is changed in btng_source.
function btng_source_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in btng_source 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
    handles = guidata(hObject); % Get handles
    switch get(eventdata.NewValue,'Tag')   % Get Tag of selected object
        case 'rbtn_energy'
            set(handles.txt_source,'String','Source type: Energy [W]')
            set(handles.rbtn_average,'Enable','on')
            set(handles.rbtn_mid,'Enable','off')
            set(handles.rbtn_edge,'Enable','off')
            set(handles.rbtn_plane,'Enable','off')
        case 'rbtn_power'
            set(handles.txt_source,'String','Source type: Power [N]')
            set(handles.rbtn_average,'Enable','off')
            set(handles.rbtn_mid,'Enable','on')
            set(handles.rbtn_edge,'Enable','on')
            set(handles.rbtn_plane,'Enable','on')
        case 'rbtn_velocity'
            set(handles.txt_source,'String','Source type: Velocity [m/s]')
            set(handles.rbtn_average,'Enable','off')
            set(handles.rbtn_mid,'Enable','on')
            set(handles.rbtn_edge,'Enable','on')
            set(handles.rbtn_plane,'Enable','on')
    end
    guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function axis_mid_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axis_mid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axis_mid


% --- Executes during object creation, after setting all properties.
function tbl_exitation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tbl_exitation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
