%**************************************************************************
% Input data file for the SEAlab
%**************************************************************************
% Example file for cavity
%
% 110513 Patrik Andersson
clear all
cd ..
enablepaths

% File name to which the results are saved in the results/ folder
%**************************************************************************
save_name='results_cavity';

% Global parameters
%**************************************************************************
load(['data' filesep 'frequencies.mat'])
data.f=fr13oct(12:end); % Frequency vector
data.numss=1;% Number of subsystems
data.numcon=0;% Number of connections (No connections only a single cavity)

   
% Subsystem parameters
%**************************************************************************
% Subsystem 1: Cavity
ns=1;
data.subsystems(ns).type='cavity'; % Type of subsystem
data.subsystems(ns).values.material=1; % Material data number refering to
                                        %   the variable 'fluids' in 
                                        %   data/physicalproperties.mat
data.subsystems(ns).values.damping.b=0.01; % Loss factor of bending waves (osbolete)
data.subsystems(ns).values.damping.l=0.01; % Loss factor of longitudinal waves
data.subsystems(ns).values.damping.s=0.01; % Loss factor of shear waves (osbolete)
data.subsystems(ns).values.dim=[4 3 3]; % Cavity dimensions [length width height]
data.subsystems(ns).values.volume=prod(data.subsystems(ns).values.dim); % Cavity volume
data.subsystems(ns).values.input_power.power.b = 0; % Input power to bending wave subsystem (obsolete)
data.subsystems(ns).values.input_power.power.l = 1; % Input power to longitudinal wave subsystem
data.subsystems(ns).values.input_power.power.s = 0; % Input power to shear wave subsystem (obsolete)

% Connection/junction parameters
%**************************************************************************

% No connections only a single cavity


%**************************************************************************
% Call the main program
%**************************************************************************
SEAlab_v0p1

%**************************************************************************
% Save the results
%**************************************************************************
save(['results' filesep save_name],'data')
